import("ingredients/cheese.lua")
import("ingredients/lettuce.lua")
import("ingredients/mushroom.lua")
import("ingredients/tomato.lua")

---@class
Ingredients = {}

local ingredientCache = {}

local _ingredientCacheIndex = 1
local maxCache = 100
for i = 1, maxCache do
    ingredientCache[i] = {}
end

local newestIngredient = {}
function Ingredients.newestIngredient()
    assert(newestIngredient.position ~= nil, "All ingredients are implicitly required to have a position component.")
    return newestIngredient
end

function Ingredients.cacheSize()
    return maxCache
end

function Ingredients.getNext(x, y)
    local index = _ingredientCacheIndex
    _ingredientCacheIndex = _ingredientCacheIndex + 1
    if _ingredientCacheIndex >= maxCache then
        _ingredientCacheIndex = 1
    end

    local o = ingredientCache[index]
    for key in pairs(o) do
        o[key] = nil
    end
    newestIngredient = o

    local odds = math.random()
    if odds > 0.3 then
        return Lettuce.initialize(o, x, y)
    elseif odds > 0.2 then
        return Tomato.initialize(o, x, y)
    elseif odds > 0.1 then
        return Mushroom.initialize(o, x, 218 + math.random(1, 5))
    else
        return Cheese.initialize(o, x, y)
    end
end
