collisionResolution = filteredSystem({ collisionBetween = T.Collision }, function(e, _, system)
    local collider, probablyCart = e.collisionBetween[1], e.collisionBetween[2]
    local colliderTop = collider.position.y

    if collider.isSolid then
        -- Assumes impact from the top
        probablyCart.position.y = colliderTop - probablyCart.size.y
    end

    if collider.canBounce and probablyCart.canBeBounced then
        probablyCart.velocity.x = probablyCart.velocity.x
            + collider.canBounce.flat.x
            + probablyCart.canBeBounced.flat.x

        probablyCart.velocity.x = probablyCart.velocity.x
            * collider.canBounce.mult.x
            * probablyCart.canBeBounced.mult.x

        -- abs() makes sure we always push upward
        probablyCart.velocity.y = math.abs(probablyCart.velocity.y)
            + collider.canBounce.flat.y
            + probablyCart.canBeBounced.flat.y

        probablyCart.velocity.y = probablyCart.velocity.y
            * collider.canBounce.mult.y
            * probablyCart.canBeBounced.mult.y
    end

    if collider.score then
        Score:add(collider.score)
    end

    if collider.expireAfterCollision then
        system.world:removeEntity(collider)
    end

    system.world:removeEntity(e)
end)
